﻿using System;
using System.Linq;

/// @author Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Demo 5,guru 4-5
/// </summary>
public class G45_RajanYlittavat
{
    /// <summary>
    /// Kutsut.
    /// </summary>
    public static void Main()
    {
        int[] luvut = { 12, 3, 5, 9, 7, 1, 4, 9 };
        int[] luvut2a = luvut.Where(x => x > 4).ToArray();
        int[] luvut2b = Array.FindAll(luvut, x => x > 4); // G4 voi tehdä myös näin
        Console.WriteLine(String.Join(", ",luvut2a));
        Console.WriteLine(luvut2a.Sum());
        
        int summa2 = luvut.Where((alkio, indeksi) => alkio > 4).Sum(); // G5. Indeksiä ei tässä käytetä, mutta sen saa Wherestä ulos tarvittaessa. Toki toimii vain sellaisille tietorakenteille joissa indeksi on olemassa (IEnumerable).
        var luvut2c = from n in luvut
                      where n > 4
                      select n;
        // Func<int, bool> f = new Func<int, bool>(x => x > 4); // funktion voisi viedä myös parametrina
        SuurempiJaParillinenIndeksi(luvut, 4);
    }

    /// <summary>
    /// tulostaa taulukosta kaikki ne luvut (alkiot), jotka ylittävät annetun rajan eli tietyn luvun ja parillisessa indeksissä. 
    /// </summary>
    /// <param name="taulukko"></param>
    /// <param name="raja"></param>
    public static void SuurempiJaParillinenIndeksi(int[] taulukko, int raja)
    {
        var luvut = taulukko.Where((x, i) => i % 2 == 0).Where(x => x > raja);
        Console.WriteLine(String.Join(" ", luvut));
    }
}